=== debian/changelog ===
maxima (5.38.1-6) unstable; urgency=medium

  * Build-dep against latest gcl
  * Bug fix: "imaxima does not load in maxima", thanks to Emmanuel
    Charpentier (Closes: #844697).

 -- Camm Maguire <camm@debian.org>  Sat, 19 Nov 2016 21:29:35 +0000

maxima (5.38.1-5) unstable; urgency=medium

  * Build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 01 Nov 2016 13:00:12 +0000

maxima (5.38.1-4) unstable; urgency=medium

  * Build-dep against latest gcl
  * Bug fix: "maxima-emacs does not work", thanks to Bastien ROUCARIES
    (Closes: #842164).

 -- Camm Maguire <camm@debian.org>  Sat, 29 Oct 2016 11:11:52 +0000

maxima (5.38.1-3) unstable; urgency=medium

  * Build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 11 Oct 2016 20:59:25 +0000

maxima (5.38.1-2) unstable; urgency=medium

  * Build-dep against latest gcl
  * Bug fix: "FTBFS: tests failures", thanks to Lucas Nussbaum (Closes:
    #831248).

 -- Camm Maguire <camm@debian.org>  Sat, 01 Oct 2016 11:37:38 +0000

maxima (5.38.1-1) unstable; urgency=medium

  * New upstream release
  * Build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Mon, 26 Sep 2016 20:19:59 +0000
