## maxima 5.39.0

=== debian/changelog ===
maxima (5.39.0-2) unstable; urgency=medium

  * fix_closeto_test_1 patch to correct 32bit test failure

 -- Camm Maguire <camm@debian.org>  Mon, 08 May 2017 20:14:14 +0000

maxima (5.39.0-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Sat, 06 May 2017 14:12:19 +0000

maxima (5.38.1-8) unstable; urgency=medium

  * Fix help system
  * Bug fix: "Maxima&#39;s online help is unreachable", thanks to Emmanuel
    Charpentier (Closes: #845430).

 -- Camm Maguire <camm@debian.org>  Fri, 25 Nov 2016 20:41:22 +0000

maxima (5.38.1-7) unstable; urgency=medium

  * Build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 22 Nov 2016 15:28:04 +0000
