=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	 interfaces/emacs/imaxima/imaxima.info interfaces/emacs/imaxima/version.texi\
 	 src/lisp\
 	 \
-	 admin/Makefile.in crosscompile-windows/Makefile.in crosscompile-windows/wxwidgets/Makefile.in\
+	 crosscompile-windows/Makefile.in admin/Makefile.in \
 	 demo/Makefile.in doc/emaxima/Makefile.in doc/info/de/Makefile.in doc/info/de.utf8/Makefile.in\
 	 doc/info/es/Makefile.in doc/info/es.utf8/Makefile.in doc/info/Makefile.in doc/info/pt_BR/Makefile.in\
 	 doc/info/pt_BR.utf8/Makefile.in doc/info/pt/Makefile.in doc/info/pt.utf8/Makefile.in doc/intromax/Makefile.in\
